//  Permission is hereby granted to merge this program code with 
//  other program material to create a derivative work.  This 
//  derivative work may be distributed in compiled object form only.
//  Any other publication of this program, in any form, without the 
//  explicit permission of the copyright holder is prohibited.
//
//  Send questions and comments to erik.j.johnson@intel.com, 
//  aaron.kunze@intel.com

//-------------------------------------------------------------------
// count.h - Chapter 5
// Dequeues packets from receive, counts them, and enqueues them
// for transmit using a single thread
//

#ifndef COUNT_H
#define COUNT_H

//-------------------------------------------------------------------
// count_init
//
//    Description:
//       Initialize the packet and byte counters.
//
//    Parameters:
//      Outputs: n/a
//      In/Outs: n/a
//      Inputs: n/a
//      Constants: n/a
//      Labels: n/a
//
//    Side effects: n/a
//
//    See also: n/a
//
void count_init();


//-------------------------------------------------------------------
// count
//
//    Description:
//       Update the packet and byte counters.
//
//    Parameters:
//      Outputs: n/a
//      In/Outs: n/a
//      Inputs: n/a
//      Constants: n/a
//      Labels: n/a
//
//    Side effects: n/a
//
//    See also: n/a
//
void count();

#endif //COUNT_H
